/***************************************************************************
 *   Copyright (C) 2007 Nicolas Hadacek <hadacek@kde.org>                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "custom_prog.h"

#include "devices/base/device_group.h"
#include "devices/list/device_list.h"

//-----------------------------------------------------------------------------
const CustomProgrammer::Action::Data CustomProgrammer::Action::DATA[Nb_Types] = {
  { "erase",       I18N_NOOP("Erase")       },
  { "read",        I18N_NOOP("Read")        },
  { "program",     I18N_NOOP("Program")     },
  { "verify",      I18N_NOOP("Verify")      },
  { "blank_check", I18N_NOOP("Blank Check") },
  { "run",         I18N_NOOP("Run")         },
  { "stop",        I18N_NOOP("Stop")        }
};

//-----------------------------------------------------------------------------
QString CustomProgrammer::Config::command(Action action)
{
  Config config;
  return config.readEntry(action.key(), QString::null);
}

void CustomProgrammer::Config::writeCommand(Action action, const QString &command)
{
  Config config;
  config.writeEntry(action.key(), command);
}

//-----------------------------------------------------------------------------
bool CustomProgrammer::Base::execute(Action action, Device::Memory *memory, const Device::MemoryRange *range)
{
  // ### TODO
  return true;
}

//-----------------------------------------------------------------------------
void CustomProgrammer::Group::initSupported()
{
  QStringList names = Device::lister().supportedDevices();
  QStringList::const_iterator it;
  for (it=names.begin(); it!=names.end(); ++it) addDevice(*it, Device::lister().data(*it), ::Group::Support::Tested);
}
